SystemOrganization addCategory: #'Kinect-Etoys'!

EllipseMorph subclass: #KinectJointMorph
	instanceVariableNames: 'jointPosition jointState'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kinect-Etoys'!

!KinectJointMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 9/10/2012 16:21'!
additionsToViewerCategories
	^ # ((kinect (
(slot jointX '' Number readOnly Player getJointX unused unused)
(slot jointY '' Number readOnly Player getJointY unused unused)
(slot jointZ '' Number readOnly Player getJointZ unused unused)
(slot jointState '' JointState readOnly Player getJointState unused unused)
)))
! !

!KinectJointMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 9/12/2012 16:44'!
initialize
	"
	self initialize
	"
	'inferred' translatedNoop.
	'tracked' translatedNoop.
	Vocabulary addStandardVocabulary: (SymbolListType new vocabularyName: #JointState;
			 symbols: #( #inferred #tracked)).! !

!KinectJointMorph methodsFor: 'viewer category filter' stamp: 'Richo 9/10/2012 16:38'!
categoriesForViewer
	^self validCategories , #(scripting)! !

!KinectJointMorph methodsFor: 'accessing' stamp: 'Richo 9/10/2012 16:24'!
jointState
	^ jointState! !

!KinectJointMorph methodsFor: 'accessing' stamp: 'Richo 9/10/2012 16:24'!
jointX
	^ jointPosition x! !

!KinectJointMorph methodsFor: 'accessing' stamp: 'Richo 9/10/2012 16:24'!
jointY
	^ jointPosition y! !

!KinectJointMorph methodsFor: 'accessing' stamp: 'Richo 9/10/2012 16:24'!
jointZ
	^ jointPosition z! !

!KinectJointMorph methodsFor: 'accessing' stamp: 'Richo 9/10/2012 16:35'!
newPlayerInstance
	^ KinectPlayer newUserInstance! !

!KinectJointMorph methodsFor: 'accessing' stamp: 'Richo 9/14/2012 17:06'!
position: aPoint3D state: trackedState
	jointPosition := aPoint3D.
	jointState := trackedState caseOf: {
			[TrackingState tracked] -> [#tracked].
			[TrackingState inferred] -> [#inferred].
			[TrackingState notTracked] -> [#notTracked]
		} otherwise: [#invalid]! !

!KinectJointMorph methodsFor: 'viewer category filter' stamp: 'Richo 9/10/2012 16:38'!
validCategories
	"Returns valid categories"
	^ (self class additionsToViewerCategories collect: [:each| each first])! !

Player subclass: #KinectPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kinect-Etoys'!

!KinectPlayer methodsFor: 'server' stamp: 'Richo 9/12/2012 17:07'!
getCameraAngle
	^ self getValueFromCostume: #cameraAngle! !

!KinectPlayer methodsFor: 'server' stamp: 'Richo 9/10/2012 17:56'!
getIsStarted
	^ self getValueFromCostume: #isStarted! !

!KinectPlayer methodsFor: 'joint' stamp: 'Richo 9/10/2012 16:23'!
getJointState
	^ self getValueFromCostume: #jointState! !

!KinectPlayer methodsFor: 'joint' stamp: 'Richo 9/10/2012 16:23'!
getJointX
	^ self getValueFromCostume: #jointX! !

!KinectPlayer methodsFor: 'joint' stamp: 'Richo 9/10/2012 16:23'!
getJointY
	^ self getValueFromCostume: #jointY! !

!KinectPlayer methodsFor: 'joint' stamp: 'Richo 9/10/2012 16:23'!
getJointZ
	^ self getValueFromCostume: #jointZ! !

!KinectPlayer methodsFor: 'server' stamp: 'Richo 9/11/2012 13:13'!
getNumberOfPlayers
	^ self getValueFromCostume: #numberOfPlayers! !

!KinectPlayer methodsFor: 'server' stamp: 'Richo 9/10/2012 17:56'!
getServerType
	^ self getValueFromCostume: #serverType! !

!KinectPlayer methodsFor: 'server' stamp: 'Richo 9/12/2012 17:15'!
setCameraAngle: aNumber
	^ self setCostumeSlot: #cameraAngle: toValue: aNumber! !

!KinectPlayer methodsFor: 'server' stamp: 'Richo 9/11/2012 13:13'!
setNumberOfPlayers: aNumber
	^ self setCostumeSlot: #numberOfPlayers: toValue: aNumber! !

!KinectPlayer methodsFor: 'server' stamp: 'Richo 9/10/2012 17:58'!
setServerType: aNumber
	^ self setCostumeSlot: #serverType: toValue: aNumber! !

!KinectPlayer methodsFor: 'server' stamp: 'Richo 9/10/2012 17:54'!
start
	^ self sendMessageToCostume: #start! !

!KinectPlayer methodsFor: 'server' stamp: 'Richo 9/10/2012 17:54'!
stop
	^ self sendMessageToCostume: #stop! !

Morph subclass: #KinectServerMorph
	instanceVariableNames: 'skeletons kinectServer informationMorph serverType startBtn stopBtn typeBtn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kinect-Etoys'!

!KinectServerMorph class methodsFor: 'viewer categories' stamp: 'Richo 9/12/2012 17:06'!
additionsToViewerCategories
	^  {{#kinect .{
	{#command . #start . ''}.
	{#command . #stop . ''}.
	{#slot . #isStarted . '' . #Boolean . #readOnly . #Player . #getIsStarted . #unused . #unused}.
	{#slot . #cameraAngle . '' . #Number . #readWrite . #Player . #getCameraAngle . #Player . #setCameraAngle:}
	"{#slot . #numberOfPlayers . '' . #Number . #readWrite . #Player . #getNumberOfPlayers . #Player . #setNumberOfPlayers:}"
	}, 	
	(KinectServer serverTypes size > 1
		ifTrue: [{{#slot . #serverType . '' . #KinectServerType . #readWrite . #Player . #getServerType . #Player . #setServerType:}}]
		ifFalse: [{}])}}! !

!KinectServerMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 9/11/2012 15:19'!
descriptionForPartsBin
	"Answer a description for use in parts bins"
	^ self partName: 	'Kinect Server' translatedNoop
		categories:		((PEUtilities isPEProject: Project current)
								ifTrue: [{'Physical Etoys' translatedNoop}]
								ifFalse: [#()])
		documentation:	''! !

!KinectServerMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 1/17/2011 16:50'!
includeInNewMorphMenu
	^true! !

!KinectServerMorph methodsFor: 'initialize' stamp: 'Richo 9/11/2012 13:36'!
addButtons
	startBtn := (SimpleButtonMorph new label: ' Start ';
			position: self topLeft + 10;
			color: (Color green mixed: 0.3 with: Color blue muchLighter);
			borderColor: #raised;
			cornerStyle: #rounded;
			borderWidth: 2;
			actionSelector: #start;
			target: self).
	stopBtn := (SimpleButtonMorph new label: ' Stop ';
			position: startBtn bottomLeft + (0@10);
			color: (Color red mixed: 0.3 with: Color blue muchLighter);
			borderColor: #raised;
			cornerStyle: #rounded;
			borderWidth: 2;
			actionSelector: #stop;
			target: self).
	typeBtn := SimpleButtonMorph new.
	typeBtn
		label: ' ', serverType, ' ';
		topRight: self topRight + (-10@10);
		color: Color transparent;
		borderColor: Color gray;
		cornerStyle: #rounded;
		borderWidth: 2;
		actionSelector: #chooseServerType:;
		arguments: {typeBtn};
		target: self.
	self addMorph: startBtn;
		addMorph: stopBtn;
		addMorph: typeBtn.
	! !

!KinectServerMorph methodsFor: 'kinect events' stamp: 'Richo 1/18/2011 18:46'!
calibrationStart: userId
	self show: 'Calibration started' forSeconds: 2! !

!KinectServerMorph methodsFor: 'accessing' stamp: 'Richo 9/12/2012 17:23'!
cameraAngle
	^ kinectServer cameraAngle! !

!KinectServerMorph methodsFor: 'accessing' stamp: 'Richo 9/12/2012 17:36'!
cameraAngle: angle
	kinectServer cameraAngle: (angle min: 27 max: -27)! !

!KinectServerMorph methodsFor: 'viewer category filter' stamp: 'Richo 9/10/2012 17:59'!
categoriesForViewer
	^self validCategories , #(scripting)! !

!KinectServerMorph methodsFor: 'button actions' stamp: 'Richo 9/11/2012 13:36'!
chooseServerType: button
	| values labels |
	values := KinectServer serverTypes keys asArray.
	values size <= 1 ifTrue: [^ self].
	labels := KinectServer serverTypes keys asArray collect: [:each | ' ', each, ' '].
	(UIManager chooseFrom: labels values: values)
		ifNotNil: [:choice |
			serverType = choice ifTrue: [^ self].
			self serverType: choice]! !

!KinectServerMorph methodsFor: 'halo' stamp: 'Richo 9/14/2012 15:55'!
defersHaloToInteriorMorph: aMorph
	"It only defers halo to interior if the morph is one of the skeleton's joints."
	^ skeletons anySatisfy: [:sk | sk anySatisfy: [:each | each = aMorph]]! !

!KinectServerMorph methodsFor: 'initialize' stamp: 'Richo 9/14/2012 14:48'!
delete
	self stop.
	super delete! !

!KinectServerMorph methodsFor: 'accessing' stamp: 'Richo 9/14/2012 15:56'!
extent: newExtent
	"Updates the joint positions"
	super extent: newExtent.
	typeBtn ifNotNil: [:btn | btn topRight: self topRight + (-10@10)].
	skeletons ifNotNil: [self positionJoints].! !

!KinectServerMorph methodsFor: 'accessing' stamp: 'Richo 9/14/2012 15:17'!
initialJointPositions
"Roughly imitating the calibration pose"
^{
	#hipRight -> (0.105 @ -0.135 @ 0.35).
	#ankleRight -> (0.12 @ -0.54 @ 0.35).
	#wristLeft -> (-0.33 @ 0.435 @ 0.35).
	#footRight -> (0.15 @ -0.585 @ 0.35).
	#shoulderCenter -> (0.0 @ 0.27 @ 0.35).
	#elbowRight -> (0.33 @ 0.27 @ 0.35).
	#wristRight -> (0.33 @ 0.435 @ 0.35).
	#handRight -> (0.33 @ 0.48 @ 0.35).
	#spine -> (0.0 @ 0.03000000000000002 @ 0.35).
	#hipLeft -> (-0.105 @ -0.135 @ 0.35).
	#footLeft -> (-0.15 @ -0.585 @ 0.35).
	#hipCenter -> (0.0 @ -0.075 @ 0.35).
	#ankleLeft -> (-0.12 @ -0.54 @ 0.35).
	#kneeRight -> (0.12 @ -0.36 @ 0.35).
	#shoulderLeft -> (-0.135 @ 0.27 @ 0.35).
	#kneeLeft -> (-0.12 @ -0.36 @ 0.35).
	#handLeft -> (-0.33 @ 0.48 @ 0.35).
	#elbowLeft -> (-0.33 @ 0.27 @ 0.35).
	#shoulderRight -> (0.135 @ 0.27 @ 0.35).
	#head -> (0.0 @ 0.435 @ 0.35).
} as: Dictionary! !

!KinectServerMorph methodsFor: 'initialize' stamp: 'Richo 9/14/2012 16:35'!
initialize
	super initialize.
	self color: Color white;
		 borderColor: Color red;
		 borderWidth: 2;
		 clipSubmorphs: true; 
		 extent:  480.0@360.0.
	self initializeServerType;
		initializeKinectServer; 
		initializeSkeletons;
		addButtons.! !

!KinectServerMorph methodsFor: 'initialize' stamp: 'Richo 9/14/2012 16:49'!
initializeKinectServer
	"Creates the Kinect server and configures its events"
	kinectServer := self newKinectServer! !

!KinectServerMorph methodsFor: 'initialize' stamp: 'Richo 9/12/2012 14:59'!
initializeServerType
	Vocabulary 
		addStandardVocabulary: (SymbolListType new
			 vocabularyName: #KinectServerType;
			 symbols: KinectServer serverTypes keys asArray).
	serverType := (KinectServer serverTypes includesKey: #FFI)
		ifTrue: [#FFI]
		ifFalse: [KinectServer serverTypes atRandom key]
! !

!KinectServerMorph methodsFor: 'initialize' stamp: 'Richo 9/14/2012 16:35'!
initializeSkeletons
	skeletons := {Dictionary new. Dictionary new}.
	1 to: 2 do: [:i |
		self initialJointPositions keysAndValuesDo: [:jointName :jointPos |
			self addMorph: ((skeletons at: i) 
				at: jointName 
				put: (self newJointMorph setNameTo: 'P', i asString, ' ' , jointName capitalized))]].
	self positionJoints! !

!KinectServerMorph methodsFor: 'accessing' stamp: 'Richo 9/10/2012 17:58'!
isStarted
	^ kinectServer isStarted! !

!KinectServerMorph methodsFor: 'accessing' stamp: 'Richo 9/14/2012 16:04'!
jointColorFor: userId
	^ userId caseOf: {
		[1] -> [Color blue].
		[2] -> [Color green]
		} otherwise: [Color yellow]! !

!KinectServerMorph methodsFor: 'accessing' stamp: 'Richo 9/14/2012 16:43'!
jointNamed: jointName for: userId
	^ ((skeletons at: userId) at: jointName)! !

!KinectServerMorph methodsFor: 'kinect events' stamp: 'Richo 1/18/2011 18:43'!
lostUser: userId
	self positionJoints; 
		 show: 'Lost user' forSeconds: 2! !

!KinectServerMorph methodsFor: 'initialize' stamp: 'Richo 9/14/2012 16:00'!
newJointMorph
	^ KinectJointMorph new
		borderWidth: 0;
		extent: 45@45;
		yourself! !

!KinectServerMorph methodsFor: 'initialize' stamp: 'Richo 9/11/2012 13:27'!
newKinectServer
	^ (KinectServer serverTypes at: serverType) new! !

!KinectServerMorph methodsFor: 'accessing' stamp: 'Richo 9/10/2012 17:53'!
newPlayerInstance
	^ KinectPlayer newUserInstance! !

!KinectServerMorph methodsFor: 'kinect events' stamp: 'Richo 1/18/2011 18:48'!
newSkeleton: userId
	self show: 'New skeleton' forSeconds: 1! !

!KinectServerMorph methodsFor: 'kinect events' stamp: 'Richo 1/18/2011 18:46'!
newUser: userId
	self show: 'New user' forSeconds: 2! !

!KinectServerMorph methodsFor: 'kinect events' stamp: 'Richo 1/18/2011 18:46'!
poseDetected: userId
	self show: 'Pose detected' forSeconds: 2! !

!KinectServerMorph methodsFor: 'updating ui' stamp: 'Richo 10/25/2012 14:43'!
position: aMorph accordingTo: aPoint3D state: trackedState user: userId
	"Moves the morph to the relative position given as a parameter.
	It also changes its size and color depending on the point's z.

	The skeleton position data ranges are:

	Values of x range from approximately -1.0 to +1.0.
	Values of y range from approximately -1.0 to +1.0.
	Values of z range from 0.0 to 1.0.
	"
	WorldState addDeferredUIMessage: [
		| x y z c min max extent |

		x := aPoint3D x.
		y := aPoint3D y.
		z := aPoint3D z.

		aMorph
			position: (x@y) + 0.5 @ z
			state: trackedState.

		c :=  trackedState caseOf: {
			[TrackingState tracked] -> [self jointColorFor: userId].
			[TrackingState inferred] -> [Color red].
			[TrackingState notTracked] -> [Color transparent]
		} otherwise: [Color yellow].

		min := (self width * (3 / 80)) @ (self height * (1/20)).
		max := (self width * (1/12)) @ (self height * (1/9)).
		extent := (min - max) * z + max.
		
		aMorph 
			center: self center + ((x @ y) * (0.72 @ -1) * (self extent / 1.5));
			extent: ((extent x min: extent y) * (1.1 @ 1.1) min: 100@100 max: 0@0);
			color: (c alphaMixed: (1 - z) with: Color transparent)
		]! !

!KinectServerMorph methodsFor: 'initialize' stamp: 'Richo 9/14/2012 17:07'!
positionJoints
	"Moves all the joints to their initial position"
	1 to: 2 do: [:userId || translation |
		"Move the skeleton to the left or to the right,
		depending on user id"
		translation := {-0.45@0 . 0.45@0}.		
		self initialJointPositions keysAndValuesDo: [:name :pos |
			self 
				position: (self jointNamed: name for: userId)
				accordingTo: pos + (translation at: userId) @ pos z
				state: TrackingState tracked
				user: userId]]! !

!KinectServerMorph methodsFor: 'fileIn/out' stamp: 'Richo 9/10/2012 16:37'!
prepareToBeSaved
	"When saving a project be sure to stop the server, otherwise we will have a lot of problems"
	super prepareToBeSaved.
	self stop! !

!KinectServerMorph methodsFor: 'accessing' stamp: 'Richo 9/10/2012 18:01'!
serverType
	^ serverType! !

!KinectServerMorph methodsFor: 'accessing' stamp: 'Richo 9/10/2012 18:02'!
serverType: aSymbol
	self stop.
	serverType := aSymbol.
	typeBtn
		label: ' ', aSymbol, ' ';
		topRight: self topRight + (-10@10).
	self initializeKinectServer! !

!KinectServerMorph methodsFor: 'updating ui' stamp: 'Richo 1/18/2011 18:48'!
show: aString forSeconds: aNumber
	"Shows a msg in the top of the morph"
	aString isEmpty ifTrue: [informationMorph ifNotNilDo: [:m | m delete]. informationMorph := nil. ^self].
	informationMorph isNil ifTrue: [self addMorph: (informationMorph := TextMorph new)].
	informationMorph contents: aString.
	informationMorph center: self center x @ (self top + informationMorph height).
	"Remove the message after x seconds"
	World addAlarm: #value withArguments: #() for: [informationMorph ifNotNilDo: [:m | m delete]. informationMorph := nil] at: (Time millisecondClockValue + (aNumber * 1000))! !

!KinectServerMorph methodsFor: 'button actions' stamp: 'Richo 9/14/2012 17:08'!
start
	""
	kinectServer start.
	kinectServer when: #jointUpdate send: #updateJoint:position:state:user: to: self.
	kinectServer when: #newUser send: #newUser: to: self.
	kinectServer when: #lostUser send: #lostUser: to: self.
	kinectServer when: #poseDetected send: #poseDetected: to: self.
	kinectServer when: #calibrationStart send: #calibrationStart: to: self.
	kinectServer when: #newSkeleton send: #newSkeleton: to: self.
	self borderColor: Color green; startStepping! !

!KinectServerMorph methodsFor: 'button actions' stamp: 'Richo 9/14/2012 16:48'!
stop
	""
	kinectServer stop.
	self borderColor: Color red;
		startStepping;
		positionJoints.! !

!KinectServerMorph methodsFor: 'kinect events' stamp: 'Richo 9/14/2012 17:07'!
updateJoint: name position: pos state: trackedState user: userId
	self
		position: (self jointNamed: name for: userId)
		accordingTo: pos
		state: trackedState
		user: userId! !

!KinectServerMorph methodsFor: 'viewer category filter' stamp: 'Richo 9/10/2012 17:59'!
validCategories
	^ (self class additionsToViewerCategories collect: [:each| each first])! !
KinectJointMorph initialize!
